"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _react = _interopRequireDefault(require("react"));

var _UUID = _interopRequireDefault(require("../UUID"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); Object.defineProperty(subClass, "prototype", { writable: false }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf ? Object.setPrototypeOf.bind() : function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } else if (call !== void 0) { throw new TypeError("Derived constructors may only return object or undefined"); } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf.bind() : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

var Validations = /*#__PURE__*/function (_React$Component) {
  _inherits(Validations, _React$Component);

  var _super = _createSuper(Validations);

  function Validations(props) {
    var _this;

    _classCallCheck(this, Validations);

    // console.log(props);
    _this = _super.call(this, props);
    _this.state = {
      element: _this.props.element,
      data: _this.props.data,
      dirty: false,
      availableRules: _this.props.element.availableValidationRules ? _this.props.element.availableValidationRules : []
    };
    return _this;
  }

  _createClass(Validations, [{
    key: "_setValue",
    value: function _setValue(text) {
      return text.replace(/[^A-Z0-9]+/ig, '_').toLowerCase();
    }
  }, {
    key: "editRule",
    value: function editRule(index, e) {
      var element = this.state.element; // const val = (element.validationRules[index].rule !== this._setValue(element.validationRules[index].text)) ? element.validationRules[index].value : this._setValue(e.target.value);

      element.validationRules[index].rule = e.target.value; // element.validationRules[index].value = val;

      this.setState({
        element: element,
        dirty: true
      });
    }
  }, {
    key: "editConstraint",
    value: function editConstraint(index, e) {
      var element = this.state.element;
      element.validationRules[index].constraint = e.target.value;
      this.setState({
        element: element,
        dirty: true
      });
    }
  }, {
    key: "updateRule",
    value: function updateRule() {
      var element = this.state.element; // to prevent ajax calls with no change

      if (this.state.dirty) {
        this.props.updateElement.call(this.props.preview, element);
        this.setState({
          dirty: false
        });
      }
    }
  }, {
    key: "addRule",
    value: function addRule(index) {
      var element = this.state.element;
      element.validationRules.splice(index + 1, 0, {
        rule: '0',
        key: _UUID["default"].uuid()
      });
      this.props.updateElement.call(this.props.preview, element);
    }
  }, {
    key: "removeRule",
    value: function removeRule(index) {
      var element = this.state.element;
      element.validationRules.splice(index, 1);
      this.props.updateElement.call(this.props.preview, element);
    }
  }, {
    key: "resetRules",
    value: function resetRules() {
      var element = this.state.element;
      element.validationRules = [{
        key: _UUID["default"].uuid(),
        rule: '0'
      }];
      this.props.updateElement.call(this.props.preview, element);
    }
  }, {
    key: "ruleHasConstraint",
    value: function ruleHasConstraint(index) {
      var rule = this.getRule(index);

      if (rule.length > 0) {
        return rule[0].hasOwnProperty('hasConstraint') && rule[0].hasConstraint;
      }

      return false;
    }
  }, {
    key: "getConstraint",
    value: function getConstraint(index) {
      var rule = this.getRule(index);

      if (rule.length > 0 && rule[0].hasOwnProperty('constraint')) {
        return rule[0].constraint;
      }

      return 'text';
    }
  }, {
    key: "getRule",
    value: function getRule(index) {
      var element = this.state.element;
      return this.state.availableRules.filter(function (x) {
        return x.key === element.validationRules[index].rule;
      });
    }
  }, {
    key: "ruleHasDescription",
    value: function ruleHasDescription(index) {
      var rule = this.getRule(index);

      if (rule.length > 0) {
        return rule[0].hasOwnProperty('description');
      }

      return false;
    }
  }, {
    key: "getDescription",
    value: function getDescription(index) {
      var rule = this.getRule(index);

      if (rule.length > 0 && rule[0].hasOwnProperty('description')) {
        return rule[0].description;
      }

      return '';
    }
  }, {
    key: "ruleIsNotSelected",
    value: function ruleIsNotSelected(r) {
      var element = this.state.element;
      var isSelected = false;
      element.validationRules.map(function (item) {
        if (item.rule === r) {
          isSelected = true;
        }

        return true;
      });
      return !isSelected;
    }
  }, {
    key: "ruleIsCurrentlySelected",
    value: function ruleIsCurrentlySelected(r, index) {
      var element = this.state.element;
      return element.validationRules[index].rule === r;
    }
  }, {
    key: "ruleIsAvailable",
    value: function ruleIsAvailable(r) {
      if (r.hasOwnProperty('onlyOn')) {
        if (Array.isArray(r.onlyOn)) {
          return r.onlyOn.includes(this.state.element.element);
        }

        return r.onlyOn === this.state.element.element;
      }

      return true;
    }
  }, {
    key: "render",
    value: function render() {
      var _this2 = this;

      if (this.state.dirty) {
        this.state.element.dirty = true;
      }

      var validationRules = this.props.element.validationRules;
      return !this.state.element["static"] ? /*#__PURE__*/_react["default"].createElement("div", {
        className: "dynamic-option-list"
      }, /*#__PURE__*/_react["default"].createElement("h6", null, "Validation Rules "), /*#__PURE__*/_react["default"].createElement("span", {
        className: "btn btn-sm btn-danger",
        style: {
          cursor: 'pointer'
        },
        onClick: function onClick() {
          _this2.resetRules();
        }
      }, /*#__PURE__*/_react["default"].createElement("small", null, "Remove all rules")), /*#__PURE__*/_react["default"].createElement("ul", null, validationRules.map(function (rule, index) {
        var key = "edit_".concat(rule.key, "_").concat(index);
        return /*#__PURE__*/_react["default"].createElement("li", {
          className: "clearfix",
          key: key
        }, /*#__PURE__*/_react["default"].createElement("div", {
          className: "row"
        }, /*#__PURE__*/_react["default"].createElement("div", {
          className: "col-sm-4 position-relative"
        }, /*#__PURE__*/_react["default"].createElement("select", {
          tabIndex: index + 1,
          className: "form-control",
          style: {
            width: '100%'
          },
          name: "rule_".concat(index),
          value: rule.rule,
          placeholder: "Validation Rule",
          onBlur: _this2.updateRule.bind(_this2),
          onChange: _this2.editRule.bind(_this2, index)
        }, /*#__PURE__*/_react["default"].createElement("option", {
          value: "0",
          disabled: true
        }, "Select rule"), _this2.state.availableRules.map(function (r) {
          if (_this2.ruleIsAvailable(r)) {
            if (_this2.ruleIsCurrentlySelected(r.key, index) || _this2.ruleIsNotSelected(r.key)) {
              return /*#__PURE__*/_react["default"].createElement("option", {
                value: r.key
              }, r.title ? r.title : r.key.charAt(0).toUpperCase() + r.key.slice(1));
            }
          }

          return null;
        })), /*#__PURE__*/_react["default"].createElement("span", {
          style: {
            position: 'absolute',
            bottom: 0,
            right: 0,
            width: '32px',
            height: '100%',
            borderRadius: '4px',
            border: '1px solid #ccc',
            backgroundColor: '#f5f5f5',
            textAlign: 'center',
            cursor: 'pointer'
          },
          onClick: function onClick(e) {
            e.currentTarget.parentNode.querySelector('select').value = '0';
          }
        }, /*#__PURE__*/_react["default"].createElement("i", {
          className: "fa fa-times",
          style: {
            lineHeight: '36px'
          }
        }))), _this2.ruleHasConstraint(index) && /*#__PURE__*/_react["default"].createElement("div", {
          className: "col-sm-5"
        }, /*#__PURE__*/_react["default"].createElement("input", {
          tabIndex: index + 1,
          className: "form-control",
          style: {
            width: '100%'
          },
          type: _this2.getConstraint(index),
          name: "rule_".concat(index),
          value: rule.constraint ? rule.constraint : '',
          placeholder: "Constraint",
          onChange: _this2.editConstraint.bind(_this2, index)
        })), /*#__PURE__*/_react["default"].createElement("div", {
          className: "col-sm-3"
        }, /*#__PURE__*/_react["default"].createElement("div", {
          className: "dynamic-options-actions-buttons"
        }, /*#__PURE__*/_react["default"].createElement("button", {
          onClick: _this2.addRule.bind(_this2, index),
          className: "btn btn-success"
        }, /*#__PURE__*/_react["default"].createElement("i", {
          className: "fas fa-plus-circle"
        })), index > 0 && /*#__PURE__*/_react["default"].createElement("button", {
          onClick: _this2.removeRule.bind(_this2, index),
          className: "btn btn-danger"
        }, /*#__PURE__*/_react["default"].createElement("i", {
          className: "fas fa-minus-circle"
        }))))), _this2.ruleHasDescription(index) && /*#__PURE__*/_react["default"].createElement("div", {
          className: "row",
          style: {
            marginTop: '5px'
          }
        }, /*#__PURE__*/_react["default"].createElement("div", {
          className: "col-sm-12"
        }, /*#__PURE__*/_react["default"].createElement("span", null, _this2.getDescription(index)))));
      }))) : null;
    }
  }]);

  return Validations;
}(_react["default"].Component);

exports["default"] = Validations;