"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _react = _interopRequireDefault(require("react"));

var _reactTextareaAutosize = _interopRequireDefault(require("react-textarea-autosize"));

var _draftJs = require("draft-js");

var _draftjsToHtml = _interopRequireDefault(require("draftjs-to-html"));

var _reactDraftWysiwyg = require("react-draft-wysiwyg");

var _dynamicOptionList = _interopRequireDefault(require("./dynamic-option-list"));

var _requests = require("./stores/requests");

var _UUID = _interopRequireDefault(require("./UUID"));

var _AutoPopulate = _interopRequireDefault(require("./form-edit-elements/AutoPopulate"));

var _Validations = _interopRequireDefault(require("./form-edit-elements/Validations"));

var _bootstrapStyle = _interopRequireDefault(require("./form-edit-elements/bootstrapStyle"));

var _Prefix = _interopRequireDefault(require("./form-edit-elements/Prefix"));

var _DynamicDropdown = _interopRequireDefault(require("./form-edit-elements/DynamicDropdown"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _unsupportedIterableToArray(arr) || _nonIterableSpread(); }

function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _iterableToArray(iter) { if (typeof Symbol !== "undefined" && iter[Symbol.iterator] != null || iter["@@iterator"] != null) return Array.from(iter); }

function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) return _arrayLikeToArray(arr); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); Object.defineProperty(subClass, "prototype", { writable: false }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf ? Object.setPrototypeOf.bind() : function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } else if (call !== void 0) { throw new TypeError("Derived constructors may only return object or undefined"); } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf.bind() : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var toolbar = {
  options: ["inline", "list", "textAlign", "fontSize", "link", "history"],
  inline: {
    inDropdown: false,
    className: undefined,
    options: ["bold", "italic", "underline", "superscript", "subscript"]
  }
};

var FormElementsEdit = /*#__PURE__*/function (_React$Component) {
  _inherits(FormElementsEdit, _React$Component);

  var _super = _createSuper(FormElementsEdit);

  function FormElementsEdit(props) {
    var _this;

    _classCallCheck(this, FormElementsEdit);

    _this = _super.call(this, props);

    _defineProperty(_assertThisInitialized(_this), "removeTag", function (i) {
      var newTags = _toConsumableArray(_this.state.tags);

      newTags.splice(i, 1);

      _this.setState({
        tags: newTags
      });
    });

    _defineProperty(_assertThisInitialized(_this), "inputKeyDown", function (e) {
      var val = e.target.value;

      if (e.key === "Enter" && val) {
        if (_this.state.tags.find(function (tag) {
          return tag.toLowerCase() === val.toLowerCase();
        })) {
          return;
        }

        _this.setState({
          tags: [].concat(_toConsumableArray(_this.state.tags), [val])
        });

        _this.tagInput.value = null;
      } else if (e.key === "Backspace" && !val) {
        _this.removeTag(_this.state.tags.length - 1);
      }
    });

    _this.state = {
      element: _this.props.element,
      data: _this.props.data,
      dirty: false,
      tags: _this.props.element.validationRule ? _this.props.element.validationRule : [],
      validation: []
    };
    return _this;
  }

  _createClass(FormElementsEdit, [{
    key: "toggleRequired",
    value: function toggleRequired() {// const this_element = this.state.element;
    }
  }, {
    key: "editElementProp",
    value: function editElementProp(elemProperty, targProperty, e) {
      var _this2 = this;

      // elemProperty could be content or label
      // targProperty could be value or checked
      var this_element = this.state.element;
      this_element[elemProperty] = e.target[targProperty];
      this_element.validationRule = this.state.tags;
      this.setState({
        element: this_element,
        dirty: true,
        validation: []
      }, function () {
        if (targProperty === "checked") {
          _this2.updateElement();
        }
      });
    }
  }, {
    key: "onEditorStateChange",
    value: function onEditorStateChange(index, property, editorContent) {
      // const html = draftToHtml(convertToRaw(editorContent.getCurrentContent())).replace(/<p>/g, '<div>').replace(/<\/p>/g, '</div>');
      var html = (0, _draftjsToHtml["default"])((0, _draftJs.convertToRaw)(editorContent.getCurrentContent())).replace(/<p>/g, "").replace(/<\/p>/g, "").replace(/&nbsp;/g, " ").replace(/(?:\r\n|\r|\n)/g, " ");
      var this_element = this.state.element;
      this_element[property] = html;
      this.setState({
        element: this_element,
        dirty: true
      });
    }
  }, {
    key: "updateElement",
    value: function updateElement() {
      var this_element = this.state.element; // to prevent ajax calls with no change

      if (this.state.dirty) {
        this.props.updateElement.call(this.props.preview, this_element);
        this.setState({
          dirty: false
        });
      }
    }
  }, {
    key: "convertFromHTML",
    value: function convertFromHTML(content) {
      var newContent = (0, _draftJs.convertFromHTML)(content);

      if (!newContent.contentBlocks || !newContent.contentBlocks.length) {
        // to prevent crash when no contents in editor
        return _draftJs.EditorState.createEmpty();
      }

      var contentState = _draftJs.ContentState.createFromBlockArray(newContent);

      return _draftJs.EditorState.createWithContent(contentState);
    }
  }, {
    key: "addOptions",
    value: function addOptions() {
      var _this3 = this;

      var optionsApiUrl = document.getElementById("optionsApiUrl").value;

      if (optionsApiUrl) {
        (0, _requests.get)(optionsApiUrl).then(function (data) {
          _this3.props.element.options = [];
          var options = _this3.props.element.options;
          data.forEach(function (x) {
            // eslint-disable-next-line no-param-reassign
            x.key = _UUID["default"].uuid();
            options.push(x);
          });
          var this_element = _this3.state.element;

          _this3.setState({
            element: this_element,
            dirty: true
          });
        });
      }
    }
  }, {
    key: "render",
    value: function render() {
      var tags = this.state.tags;

      if (this.state.dirty) {
        this.props.element.dirty = true;
      }

      var this_checked = this.props.element.hasOwnProperty("required") ? this.props.element.required : false;
      var this_read_only = this.props.element.hasOwnProperty("readOnly") ? this.props.element.readOnly : false;
      var this_default_today = this.props.element.hasOwnProperty("defaultToday") ? this.props.element.defaultToday : false;
      var this_show_time_select = this.props.element.hasOwnProperty("showTimeSelect") ? this.props.element.showTimeSelect : false;
      var this_show_time_select_only = this.props.element.hasOwnProperty("showTimeSelectOnly") ? this.props.element.showTimeSelectOnly : false;
      var this_checked_inline = this.props.element.hasOwnProperty("inline") ? this.props.element.inline : false;
      var this_checked_bold = this.props.element.hasOwnProperty("bold") ? this.props.element.bold : false;
      var this_checked_italic = this.props.element.hasOwnProperty("italic") ? this.props.element.italic : false;
      var this_checked_center = this.props.element.hasOwnProperty("center") ? this.props.element.center : false;
      var this_checked_page_break = this.props.element.hasOwnProperty("pageBreakBefore") ? this.props.element.pageBreakBefore : false;
      var this_checked_alternate_form = this.props.element.hasOwnProperty("alternateForm") ? this.props.element.alternateForm : false;
      var this_conditonal_rule = this.props.element.hasOwnProperty("conditonalRule") ? this.props.element.conditonalRule : "";
      var populateKey = this.props.element.hasOwnProperty("populateKey") ? this.props.element.populateKey : "";
      var this_validation_rule = this.props.element.hasOwnProperty("validationRule") ? this.props.element.validationRule : [];
      var this_bootstrap_rule = this.props.element.hasOwnProperty("bootstrapRule") ? this.props.element.bootstrapRule : [];
      var _this$props$element = this.props.element,
          canHavePageBreakBefore = _this$props$element.canHavePageBreakBefore,
          canHaveAlternateForm = _this$props$element.canHaveAlternateForm,
          canHaveDisplayHorizontal = _this$props$element.canHaveDisplayHorizontal,
          canHaveOptionCorrect = _this$props$element.canHaveOptionCorrect,
          canHaveOptionValue = _this$props$element.canHaveOptionValue,
          canHaveVisibilityRule = _this$props$element.canHaveVisibilityRule,
          canBeRequired = _this$props$element.canBeRequired,
          canEditFieldName = _this$props$element.canEditFieldName;
      var this_files = this.props.files.length ? this.props.files : [];

      if (this_files.length < 1 || this_files.length > 0 && this_files[0].id !== "") {
        this_files.unshift({
          id: "",
          file_name: ""
        });
      }

      var editorState;

      if (this.props.element.hasOwnProperty("content")) {
        editorState = this.convertFromHTML(this.props.element.content);
      }

      if (this.props.element.hasOwnProperty("label")) {
        editorState = this.convertFromHTML(this.props.element.label);
      }

      function getContentEditor() {
        return /*#__PURE__*/_react["default"].createElement("div", {
          className: "form-group"
        }, /*#__PURE__*/_react["default"].createElement("label", {
          className: "control-label"
        }, "Text to display:"), /*#__PURE__*/_react["default"].createElement(_reactDraftWysiwyg.Editor, {
          toolbar: toolbar,
          defaultEditorState: editorState,
          onBlur: this.updateElement.bind(this),
          onEditorStateChange: this.onEditorStateChange.bind(this, 0, "content"),
          stripPastedStyles: true
        }));
      }

      function getHrefEditor() {
        return /*#__PURE__*/_react["default"].createElement("div", {
          className: "form-group"
        }, /*#__PURE__*/_react["default"].createElement(_reactTextareaAutosize["default"], {
          type: "text",
          className: "form-control",
          defaultValue: this.props.element.href,
          onBlur: this.updateElement.bind(this),
          onChange: this.editElementProp.bind(this, "href", "value")
        }));
      }

      function getFilePathEditor() {
        return /*#__PURE__*/_react["default"].createElement("div", {
          className: "form-group"
        }, /*#__PURE__*/_react["default"].createElement("label", {
          className: "control-label",
          htmlFor: "fileSelect"
        }, "Choose file:"), /*#__PURE__*/_react["default"].createElement("select", {
          id: "fileSelect",
          className: "form-control",
          defaultValue: this.props.element.file_path,
          onBlur: this.updateElement.bind(this),
          onChange: this.editElementProp.bind(this, "file_path", "value")
        }, this_files.map(function (file) {
          var this_key = "file_".concat(file.id);
          return /*#__PURE__*/_react["default"].createElement("option", {
            value: file.id,
            key: this_key
          }, file.file_name);
        })));
      }

      function getImageSrcEditor() {
        return /*#__PURE__*/_react["default"].createElement("div", null, /*#__PURE__*/_react["default"].createElement("div", {
          className: "form-group"
        }, /*#__PURE__*/_react["default"].createElement("label", {
          className: "control-label",
          htmlFor: "srcInput"
        }, "Link to:"), /*#__PURE__*/_react["default"].createElement("input", {
          id: "srcInput",
          type: "text",
          className: "form-control",
          defaultValue: this.props.element.src,
          onBlur: this.updateElement.bind(this),
          onChange: this.editElementProp.bind(this, "src", "value")
        })), /*#__PURE__*/_react["default"].createElement("div", {
          className: "form-group"
        }, /*#__PURE__*/_react["default"].createElement("div", {
          className: "custom-control custom-checkbox"
        }, /*#__PURE__*/_react["default"].createElement("input", {
          id: "do-center",
          className: "custom-control-input",
          type: "checkbox",
          checked: this_checked_center,
          value: true,
          onChange: this.editElementProp.bind(this, "center", "checked")
        }), /*#__PURE__*/_react["default"].createElement("label", {
          className: "custom-control-label",
          htmlFor: "do-center"
        }, "Center?"))), /*#__PURE__*/_react["default"].createElement("div", {
          className: "row"
        }, /*#__PURE__*/_react["default"].createElement("div", {
          className: "col-sm-3"
        }, /*#__PURE__*/_react["default"].createElement("label", {
          className: "control-label",
          htmlFor: "elementWidth"
        }, "Width:"), /*#__PURE__*/_react["default"].createElement("input", {
          id: "elementWidth",
          type: "text",
          className: "form-control",
          defaultValue: this.props.element.width,
          onBlur: this.updateElement.bind(this),
          onChange: this.editElementProp.bind(this, "width", "value")
        })), /*#__PURE__*/_react["default"].createElement("div", {
          className: "col-sm-3"
        }, /*#__PURE__*/_react["default"].createElement("label", {
          className: "control-label",
          htmlFor: "elementHeight"
        }, "Height:"), /*#__PURE__*/_react["default"].createElement("input", {
          id: "elementHeight",
          type: "text",
          className: "form-control",
          defaultValue: this.props.element.height,
          onBlur: this.updateElement.bind(this),
          onChange: this.editElementProp.bind(this, "height", "value")
        }))));
      }

      function getFieldNameEditor() {
        return /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null, /*#__PURE__*/_react["default"].createElement("div", {
          className: "form-group"
        }, /*#__PURE__*/_react["default"].createElement("label", {
          className: "",
          htmlFor: "field_name"
        }, "Field Name (only alphabet, numbersand underscore. no spaces)"), /*#__PURE__*/_react["default"].createElement("input", {
          id: "field_name",
          placeholder: "fieldname (only alphabet and numbers. no spaces)",
          className: "form-control",
          type: "text",
          value: this.props.element.field_name,
          onChange: this.editElementProp.bind(this, "field_name", "value")
        })));
      }

      function getConditionalVisibilityEditor() {
        return /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null, /*#__PURE__*/_react["default"].createElement("div", {
          className: "form-group"
        }, /*#__PURE__*/_react["default"].createElement("label", {
          className: "",
          htmlFor: "is-conditional-rule"
        }, "Conditional Visibility Rule"), /*#__PURE__*/_react["default"].createElement("input", {
          id: "is-conditional-rule",
          placeholder: "eg: data.type == '1'? 1: 0",
          className: "form-control",
          type: "text",
          value: this_conditonal_rule,
          onChange: this.editElementProp.bind(this, "conditonalRule", "value")
        })));
      }

      function getValidationRuleEditor() {
        var _this4 = this;

        return /*#__PURE__*/_react["default"].createElement("div", {
          className: "form-group"
        }, /*#__PURE__*/_react["default"].createElement("label", {
          className: "",
          htmlFor: "is-conditional-rule"
        }, "Validation Rule"), this.props.element.hasOwnProperty("validationRule") && /*#__PURE__*/_react["default"].createElement("ul", {
          className: "input-tag__tags"
        }, tags.map(function (tag, i) {
          return /*#__PURE__*/_react["default"].createElement("li", {
            key: tag
          }, tag, /*#__PURE__*/_react["default"].createElement("button", {
            type: "button",
            onClick: function onClick() {
              _this4.removeTag(i);
            }
          }, "x"));
        })), /*#__PURE__*/_react["default"].createElement("input", {
          id: "is-conditional-rule",
          placeholder: "eg: data.type == '1'? 1: 0",
          className: "form-control",
          type: "text",
          name: "validationRule[]",
          onKeyDown: this.inputKeyDown,
          ref: function ref(c) {
            _this4.tagInput = c;
          } // value={[this.validation]}
          ,
          onChange: this.editElementProp.bind(this, "validationRule", "value")
        }));
      }

      function getAutoPopulateEditor() {
        return /*#__PURE__*/_react["default"].createElement(_AutoPopulate["default"], {
          data: this.props.preview.state.data,
          updateElement: this.props.updateElement,
          preview: this.props.preview,
          element: this.props.element,
          key: this.props.element.key
        });
      }

      function getBootstrapStyleEditor() {
        return /*#__PURE__*/_react["default"].createElement(_bootstrapStyle["default"], {
          data: this.props.preview.state.data,
          updateElement: this.props.updateElement,
          preview: this.props.preview,
          element: this.props.element,
          key: this.props.element.key
        });
      }

      function getRequiredEditor() {
        return /*#__PURE__*/_react["default"].createElement("div", {
          className: "custom-control custom-checkbox"
        }, /*#__PURE__*/_react["default"].createElement("input", {
          id: "is-required",
          className: "custom-control-input",
          type: "checkbox",
          checked: this_checked,
          value: true,
          onChange: this.editElementProp.bind(this, "required", "checked")
        }), /*#__PURE__*/_react["default"].createElement("label", {
          className: "custom-control-label",
          htmlFor: "is-required"
        }, "Required"));
      }

      function getReadOnlyEditor() {
        return /*#__PURE__*/_react["default"].createElement("div", {
          className: "custom-control custom-checkbox"
        }, /*#__PURE__*/_react["default"].createElement("input", {
          id: "is-read-only",
          className: "custom-control-input",
          type: "checkbox",
          checked: this_read_only,
          value: true,
          onChange: this.editElementProp.bind(this, "readOnly", "checked")
        }), /*#__PURE__*/_react["default"].createElement("label", {
          className: "custom-control-label",
          htmlFor: "is-read-only"
        }, "Read only"));
      }

      function getDefaultTodayEditor() {
        return /*#__PURE__*/_react["default"].createElement("div", {
          className: "custom-control custom-checkbox"
        }, /*#__PURE__*/_react["default"].createElement("input", {
          id: "is-default-to-today",
          className: "custom-control-input",
          type: "checkbox",
          checked: this_default_today,
          value: true,
          onChange: this.editElementProp.bind(this, "defaultToday", "checked")
        }), /*#__PURE__*/_react["default"].createElement("label", {
          className: "custom-control-label",
          htmlFor: "is-default-to-today"
        }, "Default to Today?"));
      }

      function getTimeSelectEditor() {
        return /*#__PURE__*/_react["default"].createElement("div", {
          className: "custom-control custom-checkbox"
        }, /*#__PURE__*/_react["default"].createElement("input", {
          id: "show-time-select",
          className: "custom-control-input",
          type: "checkbox",
          checked: this_show_time_select,
          value: true,
          onChange: this.editElementProp.bind(this, "showTimeSelect", "checked")
        }), /*#__PURE__*/_react["default"].createElement("label", {
          className: "custom-control-label",
          htmlFor: "show-time-select"
        }, "Show Time Select?"));
      }

      function getTimeSelectOnlyEditor() {
        return /*#__PURE__*/_react["default"].createElement("div", {
          className: "custom-control custom-checkbox"
        }, /*#__PURE__*/_react["default"].createElement("input", {
          id: "show-time-select-only",
          className: "custom-control-input",
          type: "checkbox",
          checked: this_show_time_select_only,
          value: true,
          onChange: this.editElementProp.bind(this, "showTimeSelectOnly", "checked")
        }), /*#__PURE__*/_react["default"].createElement("label", {
          className: "custom-control-label",
          htmlFor: "show-time-select-only"
        }, "Show Time Select Only?"));
      }

      function getDisplayHorizontalEditor() {
        return /*#__PURE__*/_react["default"].createElement("div", {
          className: "custom-control custom-checkbox"
        }, /*#__PURE__*/_react["default"].createElement("input", {
          id: "display-horizontal",
          className: "custom-control-input",
          type: "checkbox",
          checked: this_checked_inline,
          value: true,
          onChange: this.editElementProp.bind(this, "inline", "checked")
        }), /*#__PURE__*/_react["default"].createElement("label", {
          className: "custom-control-label",
          htmlFor: "display-horizontal"
        }, "Display horizonal"));
      }

      function getLabelEditor() {
        return /*#__PURE__*/_react["default"].createElement("div", {
          className: "form-group"
        }, /*#__PURE__*/_react["default"].createElement("label", null, "Display Label"), /*#__PURE__*/_react["default"].createElement(_reactDraftWysiwyg.Editor, {
          toolbar: toolbar,
          defaultEditorState: editorState,
          onBlur: this.updateElement.bind(this),
          onEditorStateChange: this.onEditorStateChange.bind(this, 0, "label"),
          stripPastedStyles: true
        }), /*#__PURE__*/_react["default"].createElement("br", null));
      }

      function getPrefixEditor() {
        return /*#__PURE__*/_react["default"].createElement(_Prefix["default"], {
          data: this.props.preview.state.data,
          updateElement: this.props.updateElement,
          preview: this.props.preview,
          element: this.props.element,
          key: this.props.element.key
        });
      }

      function getDynamicDropdownEditor() {
        return /*#__PURE__*/_react["default"].createElement(_DynamicDropdown["default"], {
          data: this.props.preview.state.data,
          updateElement: this.props.updateElement,
          preview: this.props.preview,
          element: this.props.element,
          key: this.props.element.key
        });
      }

      function getSignatureEditor() {
        return /*#__PURE__*/_react["default"].createElement("div", {
          className: "form-group"
        }, /*#__PURE__*/_react["default"].createElement("label", {
          className: "control-label",
          htmlFor: "variableKey"
        }, "Variable Key:"), /*#__PURE__*/_react["default"].createElement("input", {
          id: "variableKey",
          type: "text",
          className: "form-control",
          defaultValue: this.props.element.variableKey,
          onBlur: this.updateElement.bind(this),
          onChange: this.editElementProp.bind(this, "variableKey", "value")
        }), /*#__PURE__*/_react["default"].createElement("p", {
          className: "help-block"
        }, "This will give the element a key that can be used to replace the content with a runtime value."));
      }

      function getPageBreakEditor() {
        return /*#__PURE__*/_react["default"].createElement("div", {
          className: "form-group"
        }, /*#__PURE__*/_react["default"].createElement("label", {
          className: "control-label"
        }, "Print Options"), /*#__PURE__*/_react["default"].createElement("div", {
          className: "custom-control custom-checkbox"
        }, /*#__PURE__*/_react["default"].createElement("input", {
          id: "page-break-before-element",
          className: "custom-control-input",
          type: "checkbox",
          checked: this_checked_page_break,
          value: true,
          onChange: this.editElementProp.bind(this, "pageBreakBefore", "checked")
        }), /*#__PURE__*/_react["default"].createElement("label", {
          className: "custom-control-label",
          htmlFor: "page-break-before-element"
        }, "Page Break Before Element?")));
      }

      function getAlternateFormEditor() {
        return /*#__PURE__*/_react["default"].createElement("div", {
          className: "form-group"
        }, /*#__PURE__*/_react["default"].createElement("label", {
          className: "control-label"
        }, "Alternate/Signature Page"), /*#__PURE__*/_react["default"].createElement("div", {
          className: "custom-control custom-checkbox"
        }, /*#__PURE__*/_react["default"].createElement("input", {
          id: "display-on-alternate",
          className: "custom-control-input",
          type: "checkbox",
          checked: this_checked_alternate_form,
          value: true,
          onChange: this.editElementProp.bind(this, "alternateForm", "checked")
        }), /*#__PURE__*/_react["default"].createElement("label", {
          className: "custom-control-label",
          htmlFor: "display-on-alternate"
        }, "Display on alternate/signature Page?")));
      }

      function getStepEditor() {
        return /*#__PURE__*/_react["default"].createElement("div", {
          className: "form-group"
        }, /*#__PURE__*/_react["default"].createElement("div", {
          className: "form-group-range"
        }, /*#__PURE__*/_react["default"].createElement("label", {
          className: "control-label",
          htmlFor: "rangeStep"
        }, "Step"), /*#__PURE__*/_react["default"].createElement("input", {
          id: "rangeStep",
          type: "number",
          className: "form-control",
          defaultValue: this.props.element.step,
          onBlur: this.updateElement.bind(this),
          onChange: this.editElementProp.bind(this, "step", "value")
        })));
      }

      function getMinValueEditor() {
        return /*#__PURE__*/_react["default"].createElement("div", {
          className: "form-group"
        }, /*#__PURE__*/_react["default"].createElement("div", {
          className: "form-group-range"
        }, /*#__PURE__*/_react["default"].createElement("label", {
          className: "control-label",
          htmlFor: "rangeMin"
        }, "Min"), /*#__PURE__*/_react["default"].createElement("input", {
          id: "rangeMin",
          type: "number",
          className: "form-control",
          defaultValue: this.props.element.min_value,
          onBlur: this.updateElement.bind(this),
          onChange: this.editElementProp.bind(this, "min_value", "value")
        }), /*#__PURE__*/_react["default"].createElement("input", {
          type: "text",
          className: "form-control",
          defaultValue: this.props.element.min_label,
          onBlur: this.updateElement.bind(this),
          onChange: this.editElementProp.bind(this, "min_label", "value")
        })));
      }

      function getMaxValueEditor() {
        return /*#__PURE__*/_react["default"].createElement("div", {
          className: "form-group"
        }, /*#__PURE__*/_react["default"].createElement("div", {
          className: "form-group-range"
        }, /*#__PURE__*/_react["default"].createElement("label", {
          className: "control-label",
          htmlFor: "rangeMax"
        }, "Max"), /*#__PURE__*/_react["default"].createElement("input", {
          id: "rangeMax",
          type: "number",
          className: "form-control",
          defaultValue: this.props.element.max_value,
          onBlur: this.updateElement.bind(this),
          onChange: this.editElementProp.bind(this, "max_value", "value")
        }), /*#__PURE__*/_react["default"].createElement("input", {
          type: "text",
          className: "form-control",
          defaultValue: this.props.element.max_label,
          onBlur: this.updateElement.bind(this),
          onChange: this.editElementProp.bind(this, "max_label", "value")
        })));
      }

      function getDefaultValueEditor() {
        return /*#__PURE__*/_react["default"].createElement("div", {
          className: "form-group"
        }, /*#__PURE__*/_react["default"].createElement("div", {
          className: "form-group-range"
        }, /*#__PURE__*/_react["default"].createElement("label", {
          className: "control-label",
          htmlFor: "defaultSelected"
        }, "Default Selected"), /*#__PURE__*/_react["default"].createElement("input", {
          id: "defaultSelected",
          type: "number",
          className: "form-control",
          defaultValue: this.props.element.default_value,
          onBlur: this.updateElement.bind(this),
          onChange: this.editElementProp.bind(this, "default_value", "value")
        })));
      }

      function getTextStyleEditor() {
        return /*#__PURE__*/_react["default"].createElement("div", {
          className: "form-group"
        }, /*#__PURE__*/_react["default"].createElement("label", {
          className: "control-label"
        }, "Text Style"), /*#__PURE__*/_react["default"].createElement("div", {
          className: "custom-control custom-checkbox"
        }, /*#__PURE__*/_react["default"].createElement("input", {
          id: "do-bold",
          className: "custom-control-input",
          type: "checkbox",
          checked: this_checked_bold,
          value: true,
          onChange: this.editElementProp.bind(this, "bold", "checked")
        }), /*#__PURE__*/_react["default"].createElement("label", {
          className: "custom-control-label",
          htmlFor: "do-bold"
        }, "Bold")), /*#__PURE__*/_react["default"].createElement("div", {
          className: "custom-control custom-checkbox"
        }, /*#__PURE__*/_react["default"].createElement("input", {
          id: "do-italic",
          className: "custom-control-input",
          type: "checkbox",
          checked: this_checked_italic,
          value: true,
          onChange: this.editElementProp.bind(this, "italic", "checked")
        }), /*#__PURE__*/_react["default"].createElement("label", {
          className: "custom-control-label",
          htmlFor: "do-italic"
        }, "Italic")));
      }

      function getDescriptionEditor() {
        return /*#__PURE__*/_react["default"].createElement("div", {
          className: "form-group"
        }, /*#__PURE__*/_react["default"].createElement("label", {
          className: "control-label",
          htmlFor: "questionDescription"
        }, "Description"), /*#__PURE__*/_react["default"].createElement(_reactTextareaAutosize["default"], {
          type: "text",
          className: "form-control",
          id: "questionDescription",
          defaultValue: this.props.element.description,
          onBlur: this.updateElement.bind(this),
          onChange: this.editElementProp.bind(this, "description", "value")
        }));
      }

      function getCorrectAnswerEditor() {
        return /*#__PURE__*/_react["default"].createElement("div", {
          className: "form-group"
        }, /*#__PURE__*/_react["default"].createElement("label", {
          className: "control-label",
          htmlFor: "correctAnswer"
        }, "Correct Answer"), /*#__PURE__*/_react["default"].createElement("input", {
          id: "correctAnswer",
          type: "text",
          className: "form-control",
          defaultValue: this.props.element.correct,
          onBlur: this.updateElement.bind(this),
          onChange: this.editElementProp.bind(this, "correct", "value")
        }));
      }

      function getPopulateApiEditor() {
        return /*#__PURE__*/_react["default"].createElement("div", {
          className: "form-group"
        }, /*#__PURE__*/_react["default"].createElement("label", {
          className: "control-label",
          htmlFor: "optionsApiUrl"
        }, "Populate Options from API"), /*#__PURE__*/_react["default"].createElement("div", {
          className: "row"
        }, /*#__PURE__*/_react["default"].createElement("div", {
          className: "col-sm-6"
        }, /*#__PURE__*/_react["default"].createElement("input", {
          className: "form-control",
          style: {
            width: "100%"
          },
          type: "text",
          id: "optionsApiUrl",
          placeholder: "http://localhost:8080/api/optionsdata"
        })), /*#__PURE__*/_react["default"].createElement("div", {
          className: "col-sm-6"
        }, /*#__PURE__*/_react["default"].createElement("button", {
          onClick: this.addOptions.bind(this),
          className: "btn btn-success"
        }, "Populate"))));
      }

      function getDynamicOptionList() {
        return /*#__PURE__*/_react["default"].createElement(_dynamicOptionList["default"], {
          showCorrectColumn: this.props.showCorrectColumn,
          canHaveOptionCorrect: canHaveOptionCorrect,
          canHaveOptionValue: canHaveOptionValue,
          data: this.props.preview.state.data,
          updateElement: this.props.updateElement,
          preview: this.props.preview,
          element: this.props.element,
          key: this.props.element.options.length
        });
      }

      function getValidationEditor() {
        return /*#__PURE__*/_react["default"].createElement(_Validations["default"], {
          data: this.props.preview.state.data,
          updateElement: this.props.updateElement,
          preview: this.props.preview,
          element: this.props.element,
          key: this.props.element.key
        });
      }

      return /*#__PURE__*/_react["default"].createElement("div", null, /*#__PURE__*/_react["default"].createElement("div", {
        className: "clearfix"
      }, /*#__PURE__*/_react["default"].createElement("h4", {
        className: "float-left"
      }, this.props.element.text), /*#__PURE__*/_react["default"].createElement("i", {
        className: "float-right fas fa-times dismiss-edit",
        onClick: this.props.manualEditModeOff
      })), this.props.element.hasOwnProperty("content") && getContentEditor.call(this), this.props.element.hasOwnProperty("file_path") && getFilePathEditor.call(this), this.props.element.hasOwnProperty("href") && getHrefEditor.call(this), this.props.element.hasOwnProperty("src") && getImageSrcEditor.call(this), this.props.element.hasOwnProperty("label") && getLabelEditor.call(this), getBootstrapStyleEditor && getBootstrapStyleEditor.call(this), this.props.element.element === "AutoPopulate" && getAutoPopulateEditor.call(this), this.props.element.hasOwnProperty("label") && canEditFieldName && canEditFieldName === true && getFieldNameEditor.call(this), getConditionalVisibilityEditor.call(this), this.props.element.hasOwnProperty("label") && canBeRequired && canBeRequired === true && getRequiredEditor.call(this), this.props.element.hasOwnProperty("readOnly") && getReadOnlyEditor.call(this), this.props.element.hasOwnProperty("defaultToday") && getDefaultTodayEditor.call(this), this.props.element.hasOwnProperty("showTimeSelect") && getTimeSelectEditor.call(this), this_show_time_select && this.props.element.hasOwnProperty("showTimeSelectOnly") && getTimeSelectOnlyEditor.call(this), (this.state.element.element === "RadioButtons" || this.state.element.element === "Checkboxes") && canHaveDisplayHorizontal && getDisplayHorizontalEditor.call(this), this.state.element.element === "Signature" && this.props.element.readOnly ? getSignatureEditor.call(this) : /*#__PURE__*/_react["default"].createElement("div", null), canHavePageBreakBefore && getPageBreakEditor.call(this), canHaveAlternateForm && getAlternateFormEditor.call(this), this.props.element.hasOwnProperty("step") && getStepEditor.call(this), this.props.element.hasOwnProperty("min_value") && getMinValueEditor.call(this), this.props.element.hasOwnProperty("max_value") && getMaxValueEditor.call(this), this.props.element.hasOwnProperty("default_value") && getDefaultValueEditor.call(this), this.props.element.hasOwnProperty("static") && this.props.element["static"] && getTextStyleEditor.call(this), this.props.element.showDescription && getDescriptionEditor.call(this), this.props.showCorrectColumn && this.props.element.canHaveAnswer && !this.props.element.hasOwnProperty("options") && getCorrectAnswerEditor.call(this), this.props.element.canPopulateFromApi && this.props.element.hasOwnProperty("options") && getPopulateApiEditor.call(this), this.props.element.hasOwnProperty("options") && getDynamicOptionList.call(this), this.props.element.canHaveValidation && getValidationEditor.call(this), this.props.element.hasOwnProperty("prefix") && getPrefixEditor.call(this), this.props.element.hasOwnProperty("dropdownUrl") && getDynamicDropdownEditor.call(this));
    }
  }]);

  return FormElementsEdit;
}(_react["default"].Component);

exports["default"] = FormElementsEdit;
FormElementsEdit.defaultProps = {
  className: "edit-element-fields"
};