"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _react = _interopRequireDefault(require("react"));

var _reactDom = _interopRequireDefault(require("react-dom"));

var _fbemitter = require("fbemitter");

var _formValidator = _interopRequireDefault(require("./form-validator"));

var _formElements = _interopRequireDefault(require("./form-elements"));

var _multiColumn = require("./multi-column");

var _customElement = _interopRequireDefault(require("./form-elements/custom-element"));

var _registry = _interopRequireDefault(require("./stores/registry"));

var _dynamicDropDown = _interopRequireDefault(require("./form-elements/dynamic-drop-down"));

var _toc = _interopRequireDefault(require("./toc"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); Object.defineProperty(subClass, "prototype", { writable: false }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf ? Object.setPrototypeOf.bind() : function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } else if (call !== void 0) { throw new TypeError("Derived constructors may only return object or undefined"); } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf.bind() : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var Image = _formElements["default"].Image,
    Checkboxes = _formElements["default"].Checkboxes,
    Signature = _formElements["default"].Signature,
    FileUpload = _formElements["default"].FileUpload,
    Camera = _formElements["default"].Camera,
    Table = _formElements["default"].Table,
    Label = _formElements["default"].Label,
    AutoPopulate = _formElements["default"].AutoPopulate,
    PrefixedTextInput = _formElements["default"].PrefixedTextInput,
    NumberInput = _formElements["default"].NumberInput,
    TextArea = _formElements["default"].TextArea;

var ReactForm = /*#__PURE__*/function (_React$Component) {
  _inherits(ReactForm, _React$Component);

  var _super = _createSuper(ReactForm);

  function ReactForm(props) {
    var _this;

    _classCallCheck(this, ReactForm);

    _this = _super.call(this, props);

    _defineProperty(_assertThisInitialized(_this), "form", void 0);

    _defineProperty(_assertThisInitialized(_this), "inputs", {});

    _defineProperty(_assertThisInitialized(_this), "answerData", void 0);

    _this.answerData = _this._convert(props.answer_data);
    _this.emitter = new _fbemitter.EventEmitter();
    _this.getDataById = _this.getDataById.bind(_assertThisInitialized(_this));
    _this.state = {
      somedata: null,
      reload: ""
    };
    return _this;
  }

  _createClass(ReactForm, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      var data = this.giveMeData("update");
      this.setState({
        somedata: _objectSpread(_objectSpread({}, this.state.somedata), data),
        reload: ""
      });
    }
  }, {
    key: "componentDidUpdate",
    value: function componentDidUpdate(nextProps) {
      if (nextProps.data !== this.props.data) {
        var data = this.giveMeData("update");
        this.setState({
          somedata: _objectSpread(_objectSpread({}, this.state.somedata), data)
        });
      }
    }
  }, {
    key: "_convert",
    value: function _convert(answers) {
      if (Array.isArray(answers)) {
        var result = {};
        answers.forEach(function (x) {
          if (x.name.indexOf("tags_") > -1) {
            result[x.name] = x.value.map(function (y) {
              return y.value;
            });
          } else {
            result[x.name] = x.value;
          }
        });
        return result;
      }

      return answers || {};
    }
  }, {
    key: "_getDefaultValue",
    value: function _getDefaultValue(item) {
      return this.answerData[item.field_name];
    }
  }, {
    key: "_optionsDefaultValue",
    value: function _optionsDefaultValue(item) {
      var _this2 = this;

      var defaultValue = this._getDefaultValue(item);

      if (defaultValue) {
        return defaultValue;
      }

      var defaultChecked = [];
      item.options.forEach(function (option) {
        if (_this2.answerData["option_".concat(option.key)]) {
          defaultChecked.push(option.key);
        }
      });
      return defaultChecked;
    }
  }, {
    key: "_getItemValue",
    value: function _getItemValue(item, ref) {
      var $item = {
        element: item.element,
        value: ""
      };

      if (item.element === "Rating") {
        $item.value = ref.inputField.current.state.rating;
      } else if (item.element === "Tags") {
        $item.value = ref.inputField.current.state.value;
      } else if (item.element === "DatePicker") {
        $item.value = ref.state.value;
      } else if (item.element === "Camera") {
        $item.value = ref.state.img ? ref.state.img.replace("data:image/png;base64,", "") : "";
      } else if (ref && ref.inputField && ref.inputField.current) {
        $item = _reactDom["default"].findDOMNode(ref.inputField.current);

        if ($item && typeof $item.value === "string") {
          $item.value = $item.value.trim();
        }
      }

      return $item;
    }
  }, {
    key: "_isIncorrect",
    value: function _isIncorrect(item) {
      var incorrect = false;

      if (item.canHaveAnswer) {
        var ref = this.inputs[item.field_name];

        if (item.element === "Checkboxes" || item.element === "RadioButtons") {
          item.options.forEach(function (option) {
            var $option = _reactDom["default"].findDOMNode(ref.options["child_ref_".concat(option.key)]);

            if (option.hasOwnProperty("correct") && !$option.checked || !option.hasOwnProperty("correct") && $option.checked) {
              incorrect = true;
            }
          });
        } else {
          var $item = this._getItemValue(item, ref);

          if (item.element === "Rating") {
            if ($item.value.toString() !== item.correct) {
              incorrect = true;
            }
          } else if ($item.value.toLowerCase() !== item.correct.trim().toLowerCase()) {
            incorrect = true;
          }
        }
      }

      return incorrect;
    }
  }, {
    key: "_isInvalid",
    value: function _isInvalid(item) {
      var invalid = false;

      if (item.required === true) {
        var ref = this.inputs[item.field_name];

        if (item.element === "Checkboxes" || item.element === "RadioButtons") {
          var checked_options = 0;
          item.options.forEach(function (option) {
            var $option = _reactDom["default"].findDOMNode(ref.options["child_ref_".concat(option.key)]);

            if ($option.checked) {
              checked_options += 1;
            }
          });

          if (checked_options < 1) {
            // errors.push(item.label + ' is required!');
            invalid = true;
          }
        } else {
          var $item = this._getItemValue(item, ref);

          if (item.element === "Rating") {
            if ($item.value === 0) {
              invalid = true;
            }
          } else if ($item.value === undefined || $item.value.length < 1) {
            invalid = true;
          }
        }
      }

      return invalid;
    }
  }, {
    key: "_collect",
    value: function _collect(item) {
      var check = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : null;
      var itemData = {
        name: item.field_name,
        label: item.label ? item.label : item.field_name
      };
      var ref = this.inputs[item.field_name];

      if (ref === undefined) {
        return null;
      }

      if (item.element === "Checkboxes" || item.element === "RadioButtons") {
        var checked_options = [];
        item.options.forEach(function (option) {
          var $option = _reactDom["default"].findDOMNode(ref.options["child_ref_".concat(option.key)]);

          if ($option.checked) {
            if (check) {
              checked_options.push(option.value);
            } else {
              checked_options.push(option.value);
            }
          }
        });
        itemData.value = checked_options;
      } else if (item.element === "Table") {
        itemData.value = item.rows;
      } else {
        if (!ref) return null;
        itemData.value = this._getItemValue(item, ref).value;
      }

      return itemData;
    }
  }, {
    key: "_collectFormData",
    value: function _collectFormData(data) {
      var _this3 = this;

      var formData = [];
      data.forEach(function (item) {
        var item_data = _this3._collect(item);

        if (item_data) {
          formData.push(item_data);
        }
      });
      return formData;
    }
  }, {
    key: "_getSignatureImg",
    value: function _getSignatureImg(item) {
      var ref = this.inputs[item.field_name];
      var $canvas_sig = ref.canvas.current;

      if ($canvas_sig) {
        var base64 = $canvas_sig.toDataURL().replace("data:image/png;base64,", "");
        var isEmpty = $canvas_sig.isEmpty();

        var $input_sig = _reactDom["default"].findDOMNode(ref.inputField.current);

        if (isEmpty) {
          $input_sig.value = "";
        } else {
          $input_sig.value = base64;
        }
      }
    }
  }, {
    key: "giveMeData",
    value: function giveMeData() {
      var _this4 = this;

      var check = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : null;
      var obj = {};
      this.props.data.map(function (dat) {
        if (dat !== null) {
          var pair;

          var vala = _this4._collect(dat, check);

          if (vala != null) {
            dat.field_name = dat.field_name.replaceAll("-", "_");
            var fn = dat.field_name;
            var str = "pair = {".concat(fn, ": \"").concat(vala.value, "\"};");
            eval(str);
            obj = _objectSpread(_objectSpread({}, obj), pair);
          }
        }
      });
      return obj;
    }
  }, {
    key: "handleChange",
    value: function handleChange(event) {
      var data = this.giveMeData("update");

      for (var property in data) {
        if (event.target.name === property) {
          var xhr = new XMLHttpRequest();
          var errId = "errror-message-".concat(property);
          var parent = event.target.parentElement;
          var errorElement = parent.querySelector("#".concat(errId));
          var url = process.env.REACT_APP_VALIDATION_URL || "http://localhost:8181/api/validate";
          xhr.open("POST", "".concat(url), false);
          xhr.setRequestHeader("Content-Type", "application/x-www-form-urlencoded");
          xhr.send("formId=1&fieldId=".concat(property, "&value=").concat(data[property]));

          if (xhr.status === 200) {
            if (errorElement) {
              parent.removeChild(errorElement);
            }
          } else if (xhr.status === 412) {
            var response = JSON.parse(xhr.responseText);
            var error = response.data.errors[0];

            if (errorElement) {
              errorElement.innerText = error;
            } else {
              var errorMessage = document.createElement("span");
              errorMessage.style = "color:red";
              errorMessage.className = "text-danger";
              errorMessage.id = errId;
              errorMessage.innerText = error;
              parent.appendChild(errorMessage);
            }
          } else {
            console.log("failed to validate");
          }
        }
      }

      this.setState({
        somedata: _objectSpread(_objectSpread({}, this.state.data), data)
      });
    }
  }, {
    key: "handleSubmit",
    value: function handleSubmit(e) {
      e.preventDefault();

      var data = this._collectFormData(this.props.data);

      var errors = [];
      var btnId = e.target.id;

      if (!this.props.skip_validations && btnId && btnId === "formbuilder__submit") {
        errors = this.validateForm(); // Publish errors, if any.

        this.emitter.emit("formValidation", errors);
      } // Only submit if there are no errors.


      if (errors.length < 1) {
        var _this$props = this.props,
            onSubmit = _this$props.onSubmit,
            onSaveDraft = _this$props.onSaveDraft;
        var submissionHandler = btnId === "formbuilder__draft" ? onSaveDraft : onSubmit;

        if (submissionHandler) {
          var _data = this._collectFormData(this.props.data);

          submissionHandler(_data);
        } else {
          var $form = _reactDom["default"].findDOMNode(this.form);

          $form.submit();
        }
      }
    }
  }, {
    key: "validateForm",
    value: function validateForm() {
      var _this5 = this;

      var errors = [];
      var data_items = this.props.data;

      if (this.props.display_short) {
        data_items = this.props.data.filter(function (i) {
          return i.alternateForm === true;
        });
      }

      data_items.forEach(function (item) {
        if (item.element === "Signature") {
          _this5._getSignatureImg(item);
        }

        if (_this5._isInvalid(item)) {
          errors.push("".concat(item.label, " is required!"));
        }

        if (_this5.props.validateForCorrectness && _this5._isIncorrect(item)) {
          errors.push("".concat(item.label, " was answered incorrectly!"));
        }
      });
      return errors;
    }
  }, {
    key: "getDataById",
    value: function getDataById(id) {
      var data = this.props.data;
      console.log(data, "here is data");
      return data.find(function (x) {
        return x.id === id;
      });
    }
  }, {
    key: "getInputElement",
    value: function getInputElement(item) {
      var _this6 = this;

      var Input = _formElements["default"][item.element];
      return /*#__PURE__*/_react["default"].createElement(Input, {
        handleChange: this.handleChange,
        ref: function ref(c) {
          return _this6.inputs[item.field_name] = c;
        },
        mutable: true,
        key: "form_".concat(item.id),
        data: item,
        read_only: this.props.read_only,
        defaultValue: this._getDefaultValue(item)
      });
    }
  }, {
    key: "getPrefixedTextInputElement",
    value: function getPrefixedTextInputElement(item) {
      var _this7 = this;

      return /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null, /*#__PURE__*/_react["default"].createElement(PrefixedTextInput, {
        ref: function ref(c) {
          return _this7.inputs[item.field_name] = c;
        },
        mutable: true,
        key: "form_".concat(item.id),
        data: item,
        defaultValue: this._getDefaultValue(item)
      }));
    }
  }, {
    key: "getNumberInputElement",
    value: function getNumberInputElement(item) {
      var _this8 = this;

      return /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null, /*#__PURE__*/_react["default"].createElement(NumberInput, {
        ref: function ref(c) {
          return _this8.inputs[item.field_name] = c;
        },
        mutable: true,
        key: "form_".concat(item.id),
        data: item,
        defaultValue: this._getDefaultValue(item)
      }));
    }
  }, {
    key: "getTextAreaElement",
    value: function getTextAreaElement(item) {
      var _this9 = this;

      return /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null, /*#__PURE__*/_react["default"].createElement(TextArea, {
        ref: function ref(c) {
          return _this9.inputs[item.field_name] = c;
        },
        mutable: true,
        key: "form_".concat(item.id),
        data: item,
        defaultValue: this._getDefaultValue(item)
      }));
    }
  }, {
    key: "getDynamicDropdownElement",
    value: function getDynamicDropdownElement(item) {
      var _this10 = this;

      return /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null, /*#__PURE__*/_react["default"].createElement(_dynamicDropDown["default"], {
        ref: function ref(c) {
          return _this10.inputs[item.field_name] = c;
        },
        mutable: true,
        key: "form_".concat(item.id),
        data: item,
        defaultValue: this._getDefaultValue(item)
      }));
    }
  }, {
    key: "getAutoPopulateElement",
    value: function getAutoPopulateElement(item) {
      var _this11 = this;

      return /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null, /*#__PURE__*/_react["default"].createElement(AutoPopulate, {
        ref: function ref(c) {
          return _this11.inputs[item.field_name] = c;
        },
        mutable: true,
        key: "form_".concat(item.id),
        data: item
      }));
    }
  }, {
    key: "getContainerElement",
    value: function getContainerElement(item, Element) {
      var _this12 = this;

      var controls = item.childItems.map(function (x) {
        return x ? _this12.getInputElement(_this12.getDataById(x)) : /*#__PURE__*/_react["default"].createElement("div", null, "\xA0");
      });
      console.log(controls);
      return /*#__PURE__*/_react["default"].createElement(Element, {
        mutable: true,
        key: "form_".concat(item.id),
        data: item,
        controls: controls
      });
    }
  }, {
    key: "getSimpleElement",
    value: function getSimpleElement(item) {
      var Element = _formElements["default"][item.element];
      return /*#__PURE__*/_react["default"].createElement(Element, {
        mutable: true,
        key: "form_".concat(item.id),
        data: item
      });
    }
  }, {
    key: "getCustomElement",
    value: function getCustomElement(item) {
      var _this13 = this;

      if (!item.component || typeof item.component !== "function") {
        item.component = _registry["default"].get(item.key);

        if (!item.component) {
          console.error("".concat(item.element, " was not registered"));
        }
      }

      var inputProps = item.forwardRef && {
        handleChange: this.handleChange,
        defaultValue: this._getDefaultValue(item),
        ref: function ref(c) {
          return _this13.inputs[item.field_name] = c;
        }
      };
      return /*#__PURE__*/_react["default"].createElement(_customElement["default"], _extends({
        mutable: true,
        read_only: this.props.read_only,
        key: "form_".concat(item.id),
        data: item
      }, inputProps));
    }
  }, {
    key: "render",
    value: function render() {
      var _this14 = this;

      var data_items = this.props.data;
      var accessToken = this.props.accessToken ? this.props.accessToken : null;
      var autoPopulateUrl = this.props.autoPopulateUrl ? this.props.autoPopulateUrl : null;

      if (this.props.display_short) {
        data_items = this.props.data.filter(function (i) {
          return i.alternateForm === true;
        });
      }

      data_items.forEach(function (item) {
        item.accessToken = accessToken ? accessToken : null;
        item.autoPopulateUrl = autoPopulateUrl ? autoPopulateUrl : null;

        if (item && item.readOnly && item.variableKey && _this14.props.variables[item.variableKey]) {
          _this14.answerData[item.field_name] = _this14.props.variables[item.variableKey];
        }
      });
      var items = data_items.filter(function (x) {
        return !x.parentId;
      }).map(function (item) {
        if (_this14.state.somedata === null || _this14.state.somedata == {}) {
          return null;
        }

        var data = _this14.state.somedata;
        if (!item) return null;

        if (item.conditonalRule) {
          if (item.conditonalRule != null || item.conditonalRule != undefined) {
            if (!eval(item.conditonalRule)) {
              return null;
            }
          }
        }

        switch (item.element) {
          case "NumberInput":
            return _this14.getNumberInputElement(item);

          case "TextInput":
          case "PrefixedTextInput":
            return _this14.getPrefixedTextInputElement(item);

          case "AutoPopulate":
            return _this14.getAutoPopulateElement(item);

          case "TextArea":
            return _this14.getTextAreaElement(item);

          case "DynamicDropdown":
            return _this14.getDynamicDropdownElement(item);

          case "Dropdown":
          case "DatePicker":
          case "RadioButtons":
          case "Rating":
          case "Tags":
          case "Range":
            return _this14.getInputElement(item);

          case "CustomElement":
            return _this14.getCustomElement(item);

          case "FourColumnRow":
            return _this14.getContainerElement(item, _multiColumn.FourColumnRow);

          case "ThreeColumnRow":
            return _this14.getContainerElement(item, _multiColumn.ThreeColumnRow);

          case "TwoColumnRow":
            return _this14.getContainerElement(item, _multiColumn.TwoColumnRow);

          case "OneColumnRow":
            return _this14.getContainerElement(item, _multiColumn.OneColumnRow);

          case "ColumnRow":
            return _this14.getContainerElement(item, _multiColumn.ColumnRow);

          case "Signature":
            return /*#__PURE__*/_react["default"].createElement(Signature, {
              ref: function ref(c) {
                return _this14.inputs[item.field_name] = c;
              },
              read_only: _this14.props.read_only || item.readOnly,
              mutable: true,
              key: "form_".concat(item.id),
              data: item,
              defaultValue: _this14._getDefaultValue(item)
            });

          case "Checkboxes":
            return /*#__PURE__*/_react["default"].createElement(Checkboxes, {
              ref: function ref(c) {
                return _this14.inputs[item.field_name] = c;
              },
              read_only: _this14.props.read_only // handleChange={this.handleChange}
              ,
              handleChange: _this14.handleChange,
              mutable: true,
              key: "form_".concat(item.id),
              data: item,
              showdata: true,
              defaultValue: _this14._optionsDefaultValue(item)
            });

          case "Image":
            return /*#__PURE__*/_react["default"].createElement(Image, {
              ref: function ref(c) {
                return _this14.inputs[item.field_name] = c;
              },
              handleChange: _this14.handleChange,
              mutable: true,
              key: "form_".concat(item.id),
              data: item,
              defaultValue: _this14._getDefaultValue(item)
            });

          case "FileUpload":
            return /*#__PURE__*/_react["default"].createElement(FileUpload, {
              download_path: _this14.props.download_path,
              handleChange: _this14.handleChange,
              read_only: _this14.props.read_only || item.readOnly,
              mutable: true,
              key: "form_".concat(item.id),
              data: item,
              onFileSelect: _this14.props.onFileSelect ? _this14.props.onFileSelect : null,
              ref: function ref(c) {
                return _this14.inputs[item.field_name] = c;
              }
            });

          case "Camera":
            return /*#__PURE__*/_react["default"].createElement(Camera, {
              ref: function ref(c) {
                return _this14.inputs[item.field_name] = c;
              },
              read_only: _this14.props.read_only || item.readOnly,
              mutable: true,
              key: "form_".concat(item.id),
              data: item,
              defaultValue: _this14._getDefaultValue(item)
            });

          case "Table":
            return /*#__PURE__*/_react["default"].createElement(Table, {
              ref: function ref(c) {
                return _this14.inputs[item.field_name] = c;
              },
              read_only: _this14.props.read_only || item.readOnly,
              handleChange: _this14.handleChange,
              mutable: true,
              key: "form_".concat(item.id),
              data: item,
              showdata: true,
              defaultValue: _this14._optionsDefaultValue(item)
            });

          default:
            return _this14.getSimpleElement(item);
        }
      });
      var formTokenStyle = {
        display: "none"
      };
      var actionName = this.props.action_name ? this.props.action_name : "Submit";
      var draftActionName = this.props.draft_action_name ? this.props.draft_action_name : "Save as draft";
      var backName = this.props.back_name ? this.props.back_name : "Cancel";
      return /*#__PURE__*/_react["default"].createElement("div", null, /*#__PURE__*/_react["default"].createElement(_formValidator["default"], {
        emitter: this.emitter
      }), /*#__PURE__*/_react["default"].createElement("div", {
        className: "react-form-builder-form"
      }, /*#__PURE__*/_react["default"].createElement("form", {
        encType: "multipart/form-data",
        ref: function ref(c) {
          return _this14.form = c;
        },
        action: this.props.form_action,
        method: this.props.form_method
      }, this.props.authenticity_token && /*#__PURE__*/_react["default"].createElement("div", {
        style: formTokenStyle
      }, /*#__PURE__*/_react["default"].createElement("input", {
        name: "utf8",
        type: "hidden",
        value: "\u2713"
      }), /*#__PURE__*/_react["default"].createElement("input", {
        name: "authenticity_token",
        type: "hidden",
        value: this.props.authenticity_token
      }), /*#__PURE__*/_react["default"].createElement("input", {
        name: "task_id",
        type: "hidden",
        value: this.props.task_id
      })), items, this.props.toc ? /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null, /*#__PURE__*/_react["default"].createElement(_toc["default"], {
        text: this.props.tocText,
        buttonText: this.props.tocButtonText,
        handleChange: this.props.tocHandleChange,
        handleView: this.props.tocHandleView
      })) : null, /*#__PURE__*/_react["default"].createElement("div", {
        className: "btn-toolbar"
      }, !this.props.hide_actions && /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null, /*#__PURE__*/_react["default"].createElement("input", {
        id: "formbuilder__submit",
        type: "submit",
        onClick: this.handleSubmit.bind(this),
        className: "btn btn-school btn-big",
        value: actionName
      }), this.props.draft_action_name && /*#__PURE__*/_react["default"].createElement("input", {
        id: "formbuilder__draft",
        type: "submit",
        onClick: this.handleSubmit.bind(this),
        className: "btn btn-school btn-big",
        value: draftActionName
      })), !this.props.hide_actions && this.props.back_action && /*#__PURE__*/_react["default"].createElement("a", {
        href: this.props.back_action,
        className: "btn btn-default btn-cancel btn-big"
      }, backName)))));
    }
  }]);

  return ReactForm;
}(_react["default"].Component);

exports["default"] = ReactForm;
ReactForm.defaultProps = {
  validateForCorrectness: false
};